function Frech(Akcja, param)
% Last Modified by GUIDE v2.0 16-Oct-2001 23:59:29
%ellip(10,3,40, [0.5, 0.8])

if nargin == 0  % LAUNCH GUI

%	fig = openfig(mfilename,'reuse');  return;
  if isempty(findobj(0, 'tag', 'DrawFig_FrechGUI')) 
    
    fig = DrawFig_FrechGUI;
    set(fig,'tag', 'DrawFig_FrechGUI');
    set(fig,'NumberTitle', 'off','Name', 'Frequency response analyzer ver.1.1 (Marek.Blok@pg.edu.pl)');
    
    Frech('Init');
    Frech('Draw', 1);
  else
    Frech('Exit');
  end
  return;
end

if ~ischar(Akcja) % INVOKE NAMED SUBFUNCTION OR CALLBACK
  disp('Something''s wrong');
  return;
end

% Generate a structure of handles to pass to callbacks, and store it. 
fig=findobj(0, 'tag', 'DrawFig_FrechGUI');
hPopup=findobj(fig,'tag', 'Choose_menu');
hEdit_b=findobj(fig,'tag', 'b_edit');
hEdit_a=findobj(fig,'tag', 'a_edit');
hEditN=findobj(fig,'tag', 'N_edit');
hEditK=findobj(fig,'tag', 'K_edit');
hEditName=findobj(fig,'tag', 'Name_edit');
h_rgb(1)=findobj(fig,'tag', 'r_checkbox');
h_rgb(2)=findobj(fig,'tag', 'g_checkbox');
h_rgb(3)=findobj(fig,'tag', 'b_checkbox');
h_FRECH(1)=findobj(fig,'tag', 'Frech_radiobutton');
h_FRECH(2)=findobj(fig,'tag', 'Freqz_radiobutton');
h_FRECH(3)=findobj(fig,'tag', 'TFE_radiobutton');
h_dB=findobj(fig, 'tag', 'dB_checkbox');
h_delay=findobj(fig, 'tag', 'no_transport_delay_checkbox');
h_median=findobj(fig, 'tag', 'median_checkbox');
h_phase(1)=findobj(fig,'tag', 'unwrap_radiobutton');
h_phase(2)=findobj(fig,'tag', 'phase_delay_radiobutton');
h_phase(3)=findobj(fig,'tag', 'phase_radiobutton');
ha=get(fig, 'UserData');
Ktory=get(hPopup,'Value');  

if strcmp(Akcja, 'Exit')
  close(fig);
  return;
elseif strcmp(Akcja, 'Init')
  set(hEdit_b,'UserData','1');
  set(hEdit_b,'String','1');
  set(hEdit_a,'UserData','1');
  set(hEdit_a,'String','1');
  set(hEditN,'UserData','32');
  set(hEditN,'String','32');
  set(hEditK,'UserData','1024');
  set(hEditK,'String','1024');
  set(h_rgb(1),'UserData',[0 0 0]);
  set(h_FRECH(1),'UserData', [1 0 0]);
  set(h_FRECH(1),'Value', 1);
  set(h_FRECH(2),'Value', 0);
  set(h_FRECH(3),'Value', 0);
  ha(1)=findobj(fig,'tag', 'imp_re_axes');
  ha(2)=findobj(fig,'tag', 'imp_im_axes');
  ha(3)=findobj(fig,'tag', 'magn_axes');
  ha(4)=findobj(fig,'tag', 'phase_axes');
  ha(5)=findobj(fig,'tag', 'group_axes');
  set(fig, 'UserData', ha);
  set(hPopup,'UserData', [NaN, NaN, NaN, NaN, NaN, 1, 1, -pi, pi, -1, 1]); %handles & maximal values
  set(fig,'Units', 'pixels');
  zoom on;
  return;
elseif strcmp(Akcja, 'Check_Name')
  pom=get(hPopup,'String');
  pom2=get(hEditName,'String');
  pom(Ktory,1:length(pom2)+1)=[pom2 0];
  set(hPopup,'String',pom);
  set(hPopup, 'Value', Ktory);
  return;  
elseif strcmp(Akcja, 'New')
  pom=get(hPopup,'String');
  Ktory=size(pom,1)+1;
  pom(Ktory,1:4)=['New' 0];
  set(hPopup,'String',pom);
  pom=get(hEdit_b,'UserData');
  pom(Ktory,1:2)=['1' 0];
  set(hEdit_b,'UserData',pom);
  pom=get(hEdit_a,'UserData');
  pom(Ktory,1:2)=['1' 0];
  set(hEdit_a,'UserData',pom);
  pom=get(hEditN,'UserData');
  pom(Ktory,1:3)=['32' 0];
  set(hEditN,'UserData',pom);
  pom=get(hEditK,'UserData');
  pom(Ktory,1:5)=['1024' 0];
  set(hEditK,'UserData',pom);
  pom=get(hPopup,'UserData');
  pom(Ktory,1:size(pom,2))=ones(1,size(pom,2))*NaN;
  set(hPopup,'UserData',pom);
  pom=get(h_FRECH(1),'UserData');
  pom(Ktory,1:3)=[1 0 0];
  for ind=1:3
    set(h_FRECH(ind),'Value', pom(Ktory,ind));
  end
  set(h_FRECH(1),'UserData',pom);
  pom=get(h_rgb(1),'UserData');
  pom(Ktory,1:3)=[0 0 0];
  for ind=1:3
    set(h_rgb(ind),'Value', pom(Ktory,ind));
  end
  set(h_rgb(1),'UserData',pom);
  set(hPopup,'Value', Ktory);
  
  Frech('choose_response');
  return;
elseif strcmp(Akcja, 'Delete')
  pom=get(hPopup,'String');
  if size(pom,1)==1
    %Frech('Reset');
    return;
  end
  pom(Ktory,:)=[];
  set(hPopup,'String',pom);
  pom=get(hEdit_b,'UserData');
  pom(Ktory,:)=[];
  set(hEdit_b,'UserData',pom);
  pom=get(hEdit_a,'UserData');
  pom(Ktory,:)=[];
  set(hEdit_a,'UserData',pom);
  pom=get(hEditN,'UserData');
  pom(Ktory,:)=[];
  set(hEditN,'UserData',pom);
  pom=get(hEditK,'UserData');
  pom(Ktory,:)=[];
  set(hEditK,'UserData',pom);
  pom=get(hPopup,'UserData');
  for ind=1:5,
    if isfinite(pom(Ktory,ind))
      delete(pom(Ktory,ind));
    end
  end
  pom(Ktory,:)=[];
  set(hPopup,'UserData',pom);
  pom=get(h_FRECH(1),'UserData');
  pom(Ktory,:)=[];
  set(h_FRECH(1),'UserData',pom);
  pom=get(h_rgb(1),'UserData');
  pom(Ktory,:)=[];
  set(h_rgb(1),'UserData',pom);
  set(hPopup,'Value', 1);
  
  Frech('choose_response');
  return;
elseif strcmp(Akcja, 'choose_response')
  %selected new filter response
  pom=get(hPopup,'String');
  ind=find(pom(Ktory,:)==0);
  if isempty(ind)
    ind=size(pom,2);
  else
    ind=ind(1)-1;
  end
  set(hEditName,'String',pom(Ktory,1:ind));
  pom=get(hEdit_b,'UserData');
  set(hEdit_b, 'String', pom(Ktory,:));
  pom=get(hEdit_a,'UserData');
  set(hEdit_a, 'String', pom(Ktory,:));
  pom=get(hEditN,'UserData');
  set(hEditN, 'String', pom(Ktory,:));
  pom=get(hEditK,'UserData');
  set(hEditK, 'String', pom(Ktory,:));
  pom=get(h_FRECH(1),'UserData');
  for ind=1:3
    set(h_FRECH(ind),'Value', pom(Ktory,ind));
  end
  pom=get(h_rgb(1),'UserData');
  for ind=1:3
    set(h_rgb(ind),'Value', sign(pom(Ktory,ind)));
  end
  Frech('Draw', Ktory);
  return;
elseif strcmp(Akcja, 'Frech_radiobutton') | ...
       strcmp(Akcja, 'Freqz_radiobutton') | ...
       strcmp(Akcja, 'TFE_radiobutton')
 
  pom=get(h_FRECH(1),'UserData');
  if strcmp(Akcja, 'Frech_radiobutton')
    pom(Ktory,:)=[1 0 0];
  elseif strcmp(Akcja, 'Freqz_radiobutton')
    pom(Ktory,:)=[0 1 0];
  else
    pom(Ktory,:)=[0 0 1];
  end

  for ind=1:3
    set(h_FRECH(ind),'Value', pom(Ktory,ind));
  end
  set(h_FRECH(1),'UserData', pom);
  
  Frech('Draw', Ktory)
  return;
elseif strcmp(Akcja, 'Check_b')
  tekst=[get(hEdit_b, 'String') 0];
  pom=get(hEdit_b,'UserData');
  pom(Ktory,1:max([1; size(pom,2); length(tekst)]))= ...
     zeros(1, max([1; size(pom,2); length(tekst)]));
  pom(Ktory,1:length(tekst))=tekst;
  
  set(hEdit_b,'UserData', char(pom));
  
  Frech('Draw', Ktory)
  return;
elseif strcmp(Akcja, 'Check_a')
  tekst=[get(hEdit_a, 'String') 0]; 
  pom=get(hEdit_a,'UserData');
  pom(Ktory,1:max([1; size(pom,2); length(tekst)]))= ...
    zeros(1,max([1; size(pom,2); length(tekst)]));
  pom(Ktory,1:length(tekst))=tekst;
  
  set(hEdit_a,'UserData', char(pom));
  
  Frech('Draw', Ktory)
  return;
elseif strcmp(Akcja, 'Check_N')
  tekst=[get(hEditN, 'String') 0]; 
  pom=get(hEditN,'UserData');
  pom(Ktory,1:max([1 size(pom,2) length(tekst)]))= ...
    zeros(1,max([1 size(pom,2) length(tekst)]));
  pom(Ktory,1:length(tekst))=tekst;
  
  set(hEditN,'UserData', char(pom));
  
  Frech('Draw', Ktory)
  return;
elseif strcmp(Akcja, 'Check_K')
  tekst=[get(hEditK, 'String') 0]; 
  pom=get(hEditK,'UserData');
  pom(Ktory,1:max([1 size(pom,2) length(tekst)]))= ...
    zeros(1,max([1 size(pom,2) length(tekst)]));
  pom(Ktory,1:length(tekst))=tekst;
  
  set(hEditK,'UserData', char(pom));
  
  Frech('Draw', Ktory)
  return;
elseif strcmp(Akcja, 'Color')
  pom=get(h_rgb(1),'UserData');
  for ind=1:3
    pom(Ktory,ind)=get(h_rgb(ind),'Value')*0.75;
  end
  set(h_rgb(1),'UserData', pom);
    
  Frech('Draw', Ktory);
  return;
elseif strcmp(Akcja, 'Draw')
%  pom_pointer=get(fig, 'Pointer');
  set(fig, 'Pointer', 'Watch');
  if isstr(param)
%    if strcmp(param, 'dB')
%    elseif strcmp(param, 'no_transport_delay')
%    end
    if strcmp(param, 'phase')
      set(h_phase([1 2]),'Value', 0);
      set(h_phase(3),'Value', 1);
    elseif strcmp(param, 'phase_delay')
      set(h_phase([1 3]),'Value', 0);
      set(h_phase(2),'Value', 1);
    elseif strcmp(param, 'unwrap')
      set(h_phase([2 3]),'Value', 0);
      set(h_phase(1),'Value', 1);
    end
    
    pom=get(hPopup,'String');
    for ile=1:size(pom,1)
      Frech('Draw', ile); %Frech('Draw', 'All');
    end
  else
    Ktory=param;

    tekstN=get(hEditN,'UserData');  tekstN=tekstN(Ktory,:);
    ind=find(tekstN==0);
    if ~isempty(ind)
      tekstN=tekstN(1:ind(1)-1);
    end
    N=eval(tekstN, '2');    tekstK=get(hEditK,'UserData');  tekstK=tekstK(Ktory,:);
    ind=find(tekstK==0);
    if ~isempty(ind)
      tekstK=tekstK(1:ind(1)-1);
    end
    K=eval(tekstK, '10');
    
    n=0:N-1;
    
    tekst_b=get(hEdit_b,'UserData');  tekst_b=tekst_b(Ktory,:);
    ind=find(tekst_b==0);
    if ~isempty(ind)
      tekst_b=tekst_b(1:ind(1)-1);
    end
    eval(['[b, x]=' tekst_b ';'], 'b=NaN;')
    if isnan(b)
      tekst_b=['[ ' tekst_b ' ]'];
      b=eval(tekst_b, 'NaN');
    end
    
    tekst_a=get(hEdit_a,'UserData');  tekst_a=tekst_a(Ktory,:);
    ind=find(tekst_a==0);
    if ~isempty(ind)
      tekst_a=tekst_a(1:ind(1)-1);
    end
    eval(['[x, a]=' tekst_a ';'], 'a=NaN;')
    if isnan(a)
      tekst_a=['[ ' tekst_a ' ]'];
      a=eval(tekst_a, 'NaN');
    end
    if (any(isnan(a)) | any(isnan(b)))
      %error message
      a=1; b=1;
    end
    
    pom=get(hPopup,'UserData');
    hp_re=pom(:,1);
    hp_im=pom(:,2);
    hp_Ha=pom(:,3);
    hp_ph=pom(:,4);
    hp_gr=pom(:,5);
    max_h=pom(:,6);
    max_Ha=pom(:,7);
    min_Phase=pom(:,8);
    max_Phase=pom(:,9);
    min_Group=pom(:,10);
    max_Group=pom(:,11);

    pom=get(h_rgb(1),'UserData');
    kolor=pom(Ktory,:);

    %impulse response
    delta=[]; delta(N)=0; delta(1)=1;
    h=filter(b,a, delta);
    max_h(Ktory)=max([real(h) imag(h)]);
    if max_h == 0
      max_h = 1;
    end

    axes(ha(1));
    n(1:3:3*N)=0:N-1; n(2:3:3*N+1)=0:N-1; n(3:3:3*N+2)=(0:N-1)*NaN;
    x(1:3:3*N)=(0:N-1)*0; x(2:3:3*N+1)=real(h); x(3:3:3*N+2)=(0:N-1)*NaN;
    if isnan(hp_re(Ktory))
      hold on;
      hp_re(Ktory)=plot(n,x, 'Color', kolor);
      hold off;
    else
      set(hp_re(Ktory),'Xdata', n, 'Ydata', x, 'Color', kolor);
    end
    set(ha(1), 'Xlim', [-0.5, N-0.5], 'Ylim', [-1.1 1.1]*max(max_h));
    axes(ha(2));
    x(1:3:3*N)=(0:N-1)*0; x(2:3:3*N+1)=imag(h); x(3:3:3*N+2)=(0:N-1)*NaN;
    if isnan(hp_im(Ktory))
      hold on;
      hp_im(Ktory)=plot(n,x, 'Color', kolor);
      hold off;
    else
      set(hp_im(Ktory),'Xdata', n, 'Ydata', x, 'Color', kolor);
    end
    set(ha(2), 'Xlim', [-0.5, N-0.5], 'Ylim', [-1.1 1.1]*max(max_h));
    %frequency responses
    v=linspace(-0.5,0.5, K+1);  v=v(1:K);
    v=v(:);
    pom=get(h_FRECH(1),'UserData');
    if pom(Ktory,1)==1 %FRECH
      H = fftshift(fft(h,K));
    elseif pom(Ktory,2)==1 %Freqz
      H = fftshift(freqz(b,a,K, 'whole'));
    else %if pom(Ktory,3)==1 %TFE
      x=randn(1,K*5)+j*randn(1,K*5);
      y=filter(b,a, x);
      %(NFFT+1)/2=K   
      H = fftshift(tfestimate(x,y,K));
    end
    H=H(:);
    Ha=abs(H);
    max_Ha(Ktory)=max(Ha(isfinite(Ha)));
    Hphase=angle(H);
    Hgroup=angle(H(1:K-1).*conj(H(2:K)))/(2*pi)*K;
    if get(h_delay,'Value')==1
      if (length(a)==1)
        Hgroup=Hgroup-(length(b)-1)/2;
        H_=H.*exp(j*(length(b)-1)*pi*v);
      else
        Hgroup=Hgroup-(N-1)/2;
        H_=H.*exp(j*(N-1)*pi*v);
      end
    else
      H_=H;
    end
    
    %phase response
    if get(h_phase(3),'Value')
      Hphase=angle(H_);
      min_Phase(Ktory)=-pi;
      max_Phase(Ktory)=pi;
    else
      %unwrapped phase
      %here on the basis of the group delay we'll compute unwrapped phase
      %zero frequency (DC)
      Hphase(K/2+[0 1 2])=angle(H_(K/2+[0 1 2]));
      Hphase((K/2+3):K)=angle(conj(H_((K/2+2):K-1)).*H_((K/2+3):K));
      Hphase((K/2+2):K)=cumsum(Hphase((K/2+2):K));
      Hphase((K/2-1):-1:1)=angle(conj(H_(K/2:-1:2)).*H_((K/2-1):-1:1));
      Hphase(K/2:-1:1)=cumsum(Hphase(K/2:-1:1));
      
      if get(h_phase(2),'Value')
        %phase delay
        Hphase=-Hphase./(2*pi*v);
      end

      min_Phase(Ktory)=min(Hphase(isfinite(Hphase)));
      max_Phase(Ktory)=max(Hphase(isfinite(Hphase)));
      min_Phase(Ktory)=min_Phase(Ktory)-max([max_Phase(Ktory)-min_Phase(Ktory), 0.1])/20;
      max_Phase(Ktory)=max_Phase(Ktory)+max([max_Phase(Ktory)-min_Phase(Ktory), 0.1])/20;
    end
    
    %median filter
    if get(h_median,'Value')==1
      Hgroup=Hgroup(:).';
      Hgroup=[[Hgroup(1,3:length(Hgroup)) Hgroup(1,length(Hgroup)-[2, 1])]; ...
              [Hgroup(1,2:length(Hgroup)) Hgroup(1,length(Hgroup)-1)]; ...
              Hgroup; ...
              [Hgroup(1,2) Hgroup(1,1:length(Hgroup)-1)]; ...
              [Hgroup(1,[2 3]) Hgroup(1,1:length(Hgroup)-2)]];
      Hgroup=median(Hgroup);
    end

    min_Group(Ktory)=min(Hgroup(isfinite(Hgroup)));
    max_Group(Ktory)=max(Hgroup(isfinite(Hgroup)));
    min_Group(Ktory)=min_Group(Ktory)-max([max_Group(Ktory)-min_Group(Ktory), 0.1])/20;
    max_Group(Ktory)=max_Group(Ktory)+max([max_Group(Ktory)-min_Group(Ktory), 0.1])/20;

    if get(h_phase(2),'Value')
      %phase delay
      max_Group(Ktory)=max([max_Group(Ktory) max_Phase(Ktory)]);
      max_Phase(Ktory)=max_Group(Ktory);
      min_Group(Ktory)=min([min_Group(Ktory) min_Phase(Ktory)]);
      min_Phase(Ktory)=min_Group(Ktory);
    end
    
    %magnitude response
    axes(ha(3));
    if get(h_dB,'Value')==0
      if isnan(hp_Ha(Ktory))
        hold on;
        hp_Ha(Ktory)=plot(v,Ha, 'Color', kolor);
        hold off;
      else
        set(hp_Ha(Ktory),'Xdata', v, 'Ydata', Ha, 'Color', kolor);
      end
      set(ha(3), 'Xlim', [-0.5, 0.5], 'Ylim', [0 1.1]*max(max_Ha));
    else
      if isnan(hp_Ha(Ktory))
        hold on;
        hp_Ha(Ktory)=plot(v,20*log10(Ha), 'Color', kolor);
        hold off;
      else
        set(hp_Ha(Ktory),'Xdata', v, 'Ydata', 20*log10(Ha), 'Color', kolor);
      end
      set(ha(3), 'Xlim', [-0.5, 0.5], 'Ylim', [-60 5]+20*log10(max(max_Ha)));
    end
    
    %phase response / delay
    axes(ha(4));
    if isnan(hp_ph(Ktory))
      hold on;
      hp_ph(Ktory)=plot(v,Hphase, 'Color', kolor);
      hold off;
    else
      set(hp_ph(Ktory),'Xdata', v, 'Ydata', Hphase, 'Color', kolor);
    end
    set(ha(4), 'Xlim', [-0.5, 0.5], 'Ylim', [min(min_Phase(isfinite(min_Phase))) max(max_Phase(isfinite(max_Phase)))]);
    
    %group delay
    axes(ha(5));
    if isnan(hp_gr(Ktory))
      hold on;
      hp_gr(Ktory)=plot(v(1:K-1)+(v(2)-v(1))/2,Hgroup, 'Color', kolor);
      hold off;
    else
      set(hp_gr(Ktory),'Xdata', v(1:K-1)+(v(2)-v(1))/2, 'Ydata', Hgroup, 'Color', kolor);
    end
    set(ha(5), 'Xlim', [-0.5, 0.5], 'Ylim', [min(min_Group(isfinite(min_Group))) max(max_Group(isfinite(max_Group)))]);
    
%    [max_h; max_Ha]
    set(hPopup,'UserData', [hp_re, hp_im, hp_Ha, hp_ph, hp_gr, max_h, max_Ha, min_Phase, max_Phase, min_Group, max_Group]);
  end
  
%  set(fig, 'Pointer', pom_pointer);
  set(fig, 'Pointer', 'arrow');

  for ind=1:5
    eval('rmappdata(get(ha(ind),''Zlabel''),''ZOOMAxesData'')','set(get(ha(ind),''ZLabel''),''UserData'',[])');
  end
  zoom on;
  return;
end  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function fig_h=DrawFig_FrechGUI
fig_h=figure;
set(fig_h, ...
  'Units', 'Normalized',...
  'Position', [0.1297 0.1615 0.7242 0.6771],...
  'Color', [1.0000 1.0000 1.0000],...
  'Name', 'Untitled',...
  'NumberTitle', 'off',...
  'Menu', 'none',...
  'Tag', 'figure1'...
  );
h=axes;
set(h, ...
  'Units', 'Normalized',...
  'Position', [0.2535 0.5585 0.3430 0.1877],...
  'Color', [1.0000 1.0000 1.0000],...
  'XColor', [0.0000 0.0000 0.0000],...
  'YColor', [0.0000 0.0000 0.0000],...
  'FontSize', 8,...
  'Box', 'on',...
  'Tag', 'imp_im_axes'...
  );
h=axes;
set(h, ...
  'Units', 'Normalized',...
  'Position', [0.6408 0.1092 0.3430 0.3631],...
  'Color', [1.0000 1.0000 1.0000],...
  'XColor', [0.0000 0.0000 0.0000],...
  'YColor', [0.0000 0.0000 0.0000],...
  'FontSize', 8,...
  'Box', 'on',...
  'Tag', 'group_axes'...
  );
h=axes;
set(h, ...
  'Units', 'Normalized',...
  'Position', [0.2513 0.1123 0.3517 0.3615],...
  'Color', [1.0000 1.0000 1.0000],...
  'XColor', [0.0000 0.0000 0.0000],...
  'YColor', [0.0000 0.0000 0.0000],...
  'FontSize', 8,...
  'Box', 'on',...
  'Tag', 'phase_axes'...
  );
h=axes;
set(h, ...
  'Units', 'Normalized',...
  'Position', [0.6419 0.5554 0.3409 0.3985],...
  'Color', [1.0000 1.0000 1.0000],...
  'XColor', [0.0000 0.0000 0.0000],...
  'YColor', [0.0000 0.0000 0.0000],...
  'FontSize', 8,...
  'Box', 'on',...
  'Tag', 'magn_axes'...
  );
h=axes;
set(h, ...
  'Units', 'Normalized',...
  'Position', [0.2546 0.7846 0.3409 0.1800],...
  'Color', [1.0000 1.0000 1.0000],...
  'XColor', [0.0000 0.0000 0.0000],...
  'YColor', [0.0000 0.0000 0.0000],...
  'FontSize', 8,...
  'Box', 'on',...
  'Tag', 'imp_re_axes'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'frame',...
  'Units', 'Normalized',...
  'Position', [0.0097 0.0631 0.2060 0.4262],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', '',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'frame3'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'frame',...
  'Units', 'Normalized',...
  'Position', [0.0108 0.4969 0.2050 0.1000],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', '',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'frame2'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'frame',...
  'Units', 'Normalized',...
  'Position', [0.0108 0.6046 0.2050 0.2615],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', '',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'frame1'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'text',...
  'Units', 'Normalized',...
  'Position', [0.1090 0.6569 0.0507 0.0231],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'K =',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'text11'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'edit',...
  'Units', 'Normalized',...
  'Position', [0.1251 0.6154 0.0831 0.0415],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'Edit Text',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Check_K'')',...
  'Tag', 'K_edit'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'text',...
  'Units', 'Normalized',...
  'Position', [0.0183 0.6569 0.0507 0.0231],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'N =',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'text10'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'edit',...
  'Units', 'Normalized',...
  'Position', [0.0345 0.6169 0.0550 0.0400],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'Edit Text',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Check_N'')',...
  'Tag', 'N_edit'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'checkbox',...
  'Units', 'Normalized',...
  'Position', [0.8371 0.0569 0.1370 0.0246],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'median filter',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Draw'', ''median'')',...
  'Tag', 'median_checkbox'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'checkbox',...
  'Units', 'Normalized',...
  'Position', [0.5534 0.0092 0.1780 0.0246],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'remove transport delay',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Draw'', ''no_transport_delay'')',...
  'Tag', 'no_transport_delay_checkbox'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'radiobutton',...
  'Units', 'Normalized',...
  'Position', [0.3819 0.0554 0.1392 0.0277],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'unwrapped phase',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Draw'', ''unwrap'')',...
  'Tag', 'unwrap_radiobutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'pushbutton',...
  'Units', 'Normalized',...
  'Position', [0.1650 0.8246 0.0431 0.0338],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'Save',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Save'')',...
  'Tag', 'Save_pushbutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'pushbutton',...
  'Units', 'Normalized',...
  'Position', [0.1165 0.8246 0.0442 0.0338],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'Load',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Load'')',...
  'Tag', 'Load_pushbutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'pushbutton',...
  'Units', 'Normalized',...
  'Position', [0.0669 0.8246 0.0431 0.0338],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'Delete',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Delete'')',...
  'Tag', 'Delete_pushbutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'edit',...
  'Units', 'Normalized',...
  'Position', [0.0097 0.8738 0.2050 0.0431],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'New',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Check_Name'')',...
  'Tag', 'Name_edit'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'text',...
  'Units', 'Normalized',...
  'Position', [0.0162 0.0815 0.1877 0.4062],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'Parameters',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'Param_text'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'checkbox',...
  'Units', 'Normalized',...
  'Position', [0.1607 0.5046 0.0367 0.0215],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'b',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Color'', ''b'')',...
  'Tag', 'b_checkbox'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'checkbox',...
  'Units', 'Normalized',...
  'Position', [0.1618 0.5323 0.0367 0.0215],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'g',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Color'', ''g'')',...
  'Tag', 'g_checkbox'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'checkbox',...
  'Units', 'Normalized',...
  'Position', [0.1629 0.5600 0.0367 0.0215],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'r',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Color'',''r'')',...
  'Tag', 'r_checkbox'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'radiobutton',...
  'Units', 'Normalized',...
  'Position', [0.5286 0.0585 0.1176 0.0215],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'phase delay',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Draw'', ''phase_delay'')',...
  'Tag', 'phase_delay_radiobutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'radiobutton',...
  'Units', 'Normalized',...
  'Position', [0.2503 0.0585 0.1208 0.0215],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'phase response',...
  'Value', 1,...
  'Visible', 'on',...
  'Callback', 'Frech(''Draw'', ''phase'')',...
  'Tag', 'phase_radiobutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'text',...
  'Units', 'Normalized',...
  'Position', [0.7616 0.4769 0.1057 0.0215],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'Group delay',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'text8'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'text',...
  'Units', 'Normalized',...
  'Position', [0.3668 0.4769 0.1230 0.0231],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'Phase response',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'phase_text'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'text',...
  'Units', 'Normalized',...
  'Position', [0.3625 0.9677 0.1251 0.0231],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'Impulse response',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'text6'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'text',...
  'Units', 'Normalized',...
  'Position', [0.7465 0.9631 0.1294 0.0215],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'Magnitude response',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'text5'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'checkbox',...
  'Units', 'Normalized',...
  'Position', [0.9137 0.9677 0.0583 0.0215],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', '[dB]',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Draw'', ''dB'')',...
  'Tag', 'dB_checkbox'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'pushbutton',...
  'Units', 'Normalized',...
  'Position', [0.0140 0.0169 0.0712 0.0338],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'Exit',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Exit'')',...
  'Tag', 'Exit_pushbutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'radiobutton',...
  'Units', 'Normalized',...
  'Position', [0.0302 0.5031 0.0852 0.0215],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'TFE',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''TFE_radiobutton'')',...
  'Tag', 'TFE_radiobutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'radiobutton',...
  'Units', 'Normalized',...
  'Position', [0.0302 0.5323 0.0852 0.0215],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'Freqz',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Freqz_radiobutton'')',...
  'Tag', 'Freqz_radiobutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'radiobutton',...
  'Units', 'Normalized',...
  'Position', [0.0302 0.5646 0.0852 0.0215],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'Frech',...
  'Value', 1,...
  'Visible', 'on',...
  'Callback', 'Frech(''Frech_radiobutton'')',...
  'Tag', 'Frech_radiobutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'text',...
  'Units', 'Normalized',...
  'Position', [0.0173 0.7323 0.0507 0.0231],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'a =',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'text2'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'text',...
  'Units', 'Normalized',...
  'Position', [0.0173 0.8015 0.0496 0.0215],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'b =',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', '',...
  'Tag', 'text1'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'edit',...
  'Units', 'Normalized',...
  'Position', [0.0334 0.6877 0.1715 0.0446],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'Edit Text',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Check_a'')',...
  'Tag', 'a_edit'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'edit',...
  'Units', 'Normalized',...
  'Position', [0.0324 0.7585 0.1715 0.0415],...
  'BackGroundColor', [1.0000 1.0000 1.0000],...
  'String', 'Edit Text',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''Check_b'')',...
  'Tag', 'b_edit'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'pushbutton',...
  'Units', 'Normalized',...
  'Position', [0.0183 0.8246 0.0442 0.0338],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'New',...
  'Value', 0,...
  'Visible', 'on',...
  'Callback', 'Frech(''New'')',...
  'Tag', 'New_pushbutton'...
  );
h=uicontrol;
x=version;
if (x(1)>='5')
  set(h, ...
    'FontSize', 8);
end
set(h, ...
  'Style', 'popupmenu',...
  'Units', 'Normalized',...
  'Position', [0.0108 0.9354 0.2017 0.0385],...
  'BackGroundColor', [0.9255 0.9137 0.8471],...
  'String', 'New',...
  'Value', 1,...
  'Visible', 'on',...
  'Callback', 'Frech(''choose_response'')',...
  'Tag', 'Choose_menu'...
  );
